from meta import util
from inventory import item_classes, equipment_classes
from combat import monster_classes

"""
Options - Unvisited: 
    1. Pick up gear
    2. Read letter on desk
    3. Leave

Options - Visited: 
    1. Admire self in mirror
    2. Do laundry
    3. Leave

Areas Adjacent:
    Docks
    The Stables

Monsters:
    None

People:
    None

Requirements:
    None

Exit condition:
        self.flag_pick_up_gear = True
        self.flag_read_letter = True

"""
rat = monster_classes.Rat


# Naming convention is ScenarioYourArea
class ScenarioPCHouse(object):
    def __init__(self, nav, player):
        self.PC = player
        self.nav = nav
        self.name = self.PC.player_name + "'s House"
        self.initial_description = """
Whatever you want to put here is fine.        
        """
        self.flag_pick_up_gear = False
        self.flag_read_letter = False

        self.flag_visited = False
        self.exiting = False
        self.exit_condition = False


    def pick_up_gear(self):
        print("You pack your things.")
        self.flag_pick_up_gear = True
        self.PC.inventory.append(equipment_classes.RustyKnife)
        self.PC.inventory.append(equipment_classes.WoodenShield)
        self.PC.inventory.append(item_classes.SmallAbilityPotion)
        self.PC.inventory.append(item_classes.SmallHealthPotion)


    def read_letter(self):
        print("""You slice open the envelope. Taking a moment to appreciate the fine letterhead,
your eyes gaze upon the words...""")
        self.flag_read_letter = True

    def leave(self):
        print("You walk out of here, only if you're done looking at shit.")
        self.exiting = True
        rat = monster_classes.Rat()

    def start(self):
        if self.flag_visited:
            self.visited()
        else:
            self.unvisited()

    def unvisited(self):
        # Option list to print out
        options = ["Pick up gear", "Read letter on desk"]
        # Function list to execute when menu option is selected
        exec = [self.pick_up_gear, self.read_letter]
        ev = util.EventHandler()
        print(self.initial_description)
        ev.wait_for_user()
        util.clear()
        while not self.exiting:
            # Do this if both flags are True
            if self.flag_pick_up_gear and self.flag_read_letter:
                if not self.exit_condition:
                    options.append("Leave")
                    exec.append(self.leave)
                self.exit_condition = True
            util.menu_generator(options, exec)
        self.nav.travel()

    def visited(self):
        pass


